Merge "Adding --virtual-computes to deploy.sh help output" into stable/danube
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16   local dpdk_cores pmd_cores socket_mem ovs_dpdk_perf_flag ovs_option_heat_arr
17   declare -A ovs_option_heat_arr
18
19   ovs_option_heat_arr['dpdk_cores']=OvsDpdkCoreList
20   ovs_option_heat_arr['pmd_cores']=PmdCoreList
21   ovs_option_heat_arr['socket_memory']=OvsDpdkSocketMemory
22
23   # OPNFV Default Environment and Network settings
24   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
25   DEPLOY_OPTIONS+=" -e network-environment.yaml"
26
27   # Custom Deploy Environment Templates
28   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
29     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
30       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
31     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
32       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-bgpvpn.yaml"
33       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
34         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
35       fi
36     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
37       if [ "${deploy_options_array['sdn_l3']}" == "True" ]; then
38         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb.yaml"
39       else
40         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb-l2.yaml"
41       fi
42     else
43       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
44     fi
45     SDN_IMAGE=opendaylight
46   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
47     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
48     SDN_IMAGE=opendaylight
49   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
50     echo -e "${red}ERROR: ONOS is unsupported in Danube...exiting${reset}"
51     exit 1
52     #if [ "${deploy_options_array['sfc']}" == 'True' ]; then
53     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
54     #else
55     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
56     #fi
57     #SDN_IMAGE=onos
58   elif [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
59     if [[ "$ha_enabled" == "True" ]]; then
60       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn-ha.yaml"
61       echo "${red}OVN HA support is not not supported... exiting.${reset}"
62       exit 1
63     else
64       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn.yaml"
65     fi
66     SDN_IMAGE=opendaylight
67   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
68     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
69     exit 1
70   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
71     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
72     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
73       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-vpp.yaml"
74     elif [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
75       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ovs-dpdk.yaml"
76     fi
77     SDN_IMAGE=opendaylight
78   else
79     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
80     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
81     exit 1
82   fi
83
84   # Enable Tacker
85   if [ "${deploy_options_array['tacker']}" == 'True' ]; then
86     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_tacker.yaml"
87   fi
88
89   # Enable Congress
90   if [ "${deploy_options_array['congress']}" == 'True' ]; then
91     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_congress.yaml"
92   fi
93
94   # Enable Real Time Kernel (kvm4nfv)
95   if [ "${deploy_options_array['rt_kvm']}" == 'True' ]; then
96     DEPLOY_OPTIONS+=" -e /home/stack/enable_rt_kvm.yaml"
97   fi
98
99   # Make sure the correct overcloud image is available
100   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
101       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
102       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
103       exit 1
104   fi
105
106   echo "Copying overcloud image to Undercloud"
107   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
108   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
109
110   # disable neutron openvswitch agent from starting
111   if [[ -n "${deploy_options_array['sdn_controller']}" && "${deploy_options_array['sdn_controller']}" != 'False' ]]; then
112       echo -e "${blue}INFO: Disabling neutron-openvswitch-agent from systemd${reset}"
113       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
114       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -f /etc/systemd/system/multi-user.target.wants/neutron-openvswitch-agent.service" \
115                                                --run-command "rm -f /usr/lib/systemd/system/neutron-openvswitch-agent.service" \
116                                                -a overcloud-full.qcow2
117 EOI
118   fi
119
120   if [ "${deploy_options_array['vpn']}" == 'True' ]; then
121       echo -e "${blue}INFO: Enabling ZRPC and Quagga${reset}"
122       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
123       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y install /root/quagga/*.rpm" \
124                                                --run-command "sudo usermod -a -G quaggavt quagga" \
125                                                --run-command "sudo mkdir -p /var/run/quagga/" \
126                                                --run-command "sudo chown quagga:quagga -R /var/run/quagga/" \
127                                                --run-command "systemctl enable zrpcd" \
128                                                -a overcloud-full.qcow2
129 EOI
130   fi
131
132   # Install ovs-dpdk inside the overcloud image if it is enabled.
133   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
134     # install dpdk packages before ovs
135     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
136
137     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
138       cat << EOF > vfio_pci.modules
139 #!/bin/bash
140 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
141 EOF
142
143       cat << EOF > uio_pci_generic.modules
144 #!/bin/bash
145 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
146 EOF
147
148       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
149                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
150                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
151                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
152                                                -a overcloud-full.qcow2
153
154       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
155         sed -i "/OS::TripleO::ComputeExtraConfigPre:/c\  OS::TripleO::ComputeExtraConfigPre: ./ovs-dpdk-preconfig.yaml" network-environment.yaml
156       fi
157
158 EOI
159
160   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
161     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
162     exit 1
163   fi
164
165   if [ "$debug" == 'TRUE' ]; then
166     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
167   fi
168
169   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
170   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
171     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
172          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
173                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
174                                                   -a overcloud-full.qcow2
175 EOI
176   fi
177
178   # Patch neutron with using OVS external interface for router and add generic linux NS interface driver
179   if [[ "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
180     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
181       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /usr/lib/python2.7/site-packages/ && patch -p1 < neutron-patch-NSDriver.patch" \
182                                                -a overcloud-full.qcow2
183 EOI
184
185     # Disable clustering for ODL FDIO HA scenarios
186     if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
187       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
188       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /etc/puppet/modules/tripleo/ && patch -p1 < disable_odl_clustering.patch" \
189                                                -a overcloud-full.qcow2
190 EOI
191     fi
192
193     # Configure routing node for odl_l3-fdio
194     if [[ "${deploy_options_array['sdn_l3']}" == 'True' ]]; then
195       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
196         sed -i "/opendaylight::vpp_routing_node:/c\    opendaylight::vpp_routing_node: ${deploy_options_array['odl_vpp_routing_node']}.${domain_name}" ${ENV_FILE}
197 EOI
198     fi
199   fi
200
201   if [ -n "${deploy_options_array['performance']}" ]; then
202     ovs_dpdk_perf_flag="False"
203     for option in "${performance_options[@]}" ; do
204       arr=($option)
205       # use compute's kernel settings for all nodes for now.
206       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "kernel" ]; then
207         kernel_args+=" ${arr[2]}=${arr[3]}"
208       fi
209       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "ovs" ]; then
210          eval "${arr[2]}=${arr[3]}"
211          ovs_dpdk_perf_flag="True"
212       fi
213     done
214
215     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
216       sed -i "/ComputeKernelArgs:/c\  ComputeKernelArgs: '$kernel_args'" ${ENV_FILE}
217       sed -i "$ a\resource_registry:\n  OS::TripleO::NodeUserData: first-boot.yaml" ${ENV_FILE}
218       sed -i "/NovaSchedulerDefaultFilters:/c\  NovaSchedulerDefaultFilters: 'RamFilter,ComputeFilter,AvailabilityZoneFilter,ComputeCapabilitiesFilter,ImagePropertiesFilter,NUMATopologyFilter'" ${ENV_FILE}
219 EOI
220
221     if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' && "$ovs_dpdk_perf_flag" == "True" ]]; then
222       for ovs_option in ${!ovs_option_heat_arr[@]}; do
223         if [ -n "${!ovs_option}" ]; then
224           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
225             sed -i "/${ovs_option_heat_arr[$ovs_option]}:/c\  ${ovs_option_heat_arr[$ovs_option]}: ${!ovs_option}" ${ENV_FILE}
226 EOI
227         fi
228       done
229     fi
230   fi
231
232   if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
233     if [ "${deploy_options_array['dataplane']}" == "fdio" ]; then
234       if [ "$tenant_nic_mapping_controller_members" == "$tenant_nic_mapping_compute_members" ]; then
235         ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
236           sed -i "/NeutronVPPAgentPhysnets:/c\  NeutronVPPAgentPhysnets: 'datacentre:${tenant_nic_mapping_controller_members}'" ${ENV_FILE}
237 EOI
238       else
239         echo -e "${red}Compute and Controller must use the same tenant nic name, please modify network setting file.${reset}"
240         exit 1
241       fi
242     fi
243   fi
244
245   # Set ODL version accordingly
246   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
247     case "${deploy_options_array['odl_version']}" in
248       beryllium) odl_version=''
249               ;;
250       boron)  odl_version='boron'
251               ;;
252       carbon) odl_version='master'
253               ;;
254       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
255          exit 1
256          ;;
257     esac
258
259     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
260       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
261                                                --run-command "yum -y install /root/${odl_version}/*" \
262                                                -a overcloud-full.qcow2
263 EOI
264   fi
265
266   # Override ODL if FDIO and ODL L2
267   if [[ "${deploy_options_array['vpp']}" == 'True' && "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
268     if [ "${deploy_options_array['sdn_l3']}" == "False" ]; then
269       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
270          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
271                                                   --run-command "yum -y install /root/fdio_l2/opendaylight*.rpm" \
272                                                   -a overcloud-full.qcow2
273 EOI
274     else
275       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
276          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum remove -y vpp vpp-api-python vpp-lib vpp-plugins honeycomb" \
277                                                   --run-command "yum -y install /root/fdio_l3/*.rpm" \
278                                                   -a overcloud-full.qcow2
279 EOI
280     fi
281   fi
282
283   # check if ceph should be enabled
284   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
285     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
286   fi
287
288   if [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
289     # The epoch in deloran's ovs is 1: and in leif's is 0:
290     # so we have to execute a downgrade instead of an update
291     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
292       LIBGUESTFS_BACKEND=direct virt-customize \
293         --run-command "cd /root/ovs27 && yum update -y *openvswitch*" \
294         --run-command "cd /root/ovs27 && yum downgrade -y *openvswitch*" \
295         -a overcloud-full.qcow2
296 EOI
297   fi
298
299   # get number of nodes available in inventory
300   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
301   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
302
303   # check if HA is enabled
304   if [[ "$ha_enabled" == "True" ]]; then
305     if [ "$num_control_nodes" -lt 3 ]; then
306       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
307       exit 1
308     else
309      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
310      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
311      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
312     fi
313   else
314     if [ "$num_control_nodes" -lt 1 ]; then
315       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
316       exit 1
317     fi
318   fi
319
320   if [ "$num_compute_nodes" -le 0 ]; then
321     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
322     exit 1
323   else
324     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
325     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
326   fi
327
328   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
329
330   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
331   if [[ "$virtual" == "TRUE" ]]; then
332      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
333   fi
334
335   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
336
337   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
338 # Create a key for use by nova for live migration
339 echo "Creating nova SSH key for nova resize support"
340 ssh-keygen -f nova_id_rsa -b 1024 -P ""
341 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
342 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
343 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
344 mv -f opnfv-environment-new.yaml ${ENV_FILE}
345
346 source stackrc
347 set -o errexit
348 # Workaround for APEX-207 where sometimes swift proxy is down
349 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
350   sudo systemctl restart openstack-swift-proxy
351 fi
352 echo "Uploading overcloud glance images"
353 openstack overcloud image upload
354
355 echo "Configuring undercloud and discovering nodes"
356 openstack baremetal import --json instackenv.json
357
358 if [[ -z "$virtual" ]]; then
359   openstack baremetal introspection bulk start
360   if [[ -n "$root_disk_list" ]]; then
361     openstack baremetal configure boot --root-device=${root_disk_list}
362   else
363     openstack baremetal configure boot
364   fi
365 else
366   openstack baremetal configure boot
367 fi
368
369 echo "Configuring flavors"
370 for flavor in baremetal control compute; do
371   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
372   if openstack flavor list | grep \${flavor}; then
373     openstack flavor delete \${flavor}
374   fi
375   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
376   if ! openstack flavor list | grep \${flavor}; then
377     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
378   fi
379 done
380 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
381 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
382 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
383 echo "Configuring nameserver on ctlplane network"
384 dns_server_ext=''
385 for dns_server in ${dns_servers}; do
386   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
387 done
388 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
389 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
390 echo "Executing overcloud deployment, this should run for an extended period without output."
391 sleep 60 #wait for Hypervisor stats to check-in to nova
392 # save deploy command so it can be used for debugging
393 cat > deploy_command << EOF
394 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
395 EOF
396 EOI
397
398   if [ "$interactive" == "TRUE" ]; then
399     if ! prompt_user "Overcloud Deployment"; then
400       echo -e "${blue}INFO: User requests exit${reset}"
401       exit 0
402     fi
403   fi
404
405   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
406 source stackrc
407 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
408 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
409   $(typeset -f debug_stack)
410   debug_stack
411   exit 1
412 fi
413 EOI
414
415   # Configure DPDK and restart ovs agent after bringing up br-phy
416   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
417     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
418 source stackrc
419 set -o errexit
420 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
421 echo "Checking DPDK status and bringing up br-phy on \$node"
422 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
423 set -o errexit
424 sudo dpdk-devbind -s
425 sudo ifup br-phy
426 if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
427   echo "Restarting openvswitch agent to pick up VXLAN tunneling"
428   sudo systemctl restart neutron-openvswitch-agent
429 fi
430 EOF
431 done
432 EOI
433   fi
434
435   if [ "$debug" == 'TRUE' ]; then
436       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
437 source overcloudrc
438 echo "Keystone Endpoint List:"
439 openstack endpoint list
440 echo "Keystone Service List"
441 openstack service list
442 EOI
443   fi
444 }